#include <stdio.h>
#include <string.h>

#include "id3.h"

char *genres[] = {
    "Blues", "Classic Rock", "Country", "Dance",
    "Disco", "Funk", "Grunge", "Hip-Hop",
    "Jazz", "Metal", "New Age", "Oldies",
    "Other", "Pop", "R&B", "Rap", "Reggae",
    "Rock", "Techno", "Industrial", "Alternative",
    "Ska", "Death Metal", "Pranks", "Soundtrack",
    "Euro-Techno", "Ambient", "Trip-Hop", "Vocal",
    "Jazz+Funk", "Fusion", "Trance", "Classical",
    "Instrumental", "Acid", "House", "Game",
    "Sound Clip", "Gospel", "Noise", "Alt",
    "Bass", "Soul", "Punk", "Space",
    "Meditative", "Instrumental Pop",
    "Instrumental Rock", "Ethnic", "Gothic",
    "Darkwave", "Techno-Industrial", "Electronic",
    "Pop-Folk", "Eurodance", "Dream",
    "Southern Rock", "Comedy", "Cult",
    "Gangsta Rap", "Top 40", "Christian Rap",
    "Pop/Funk", "Jungle", "Native American",
    "Cabaret", "New Wave", "Psychedelic", "Rave",
    "Showtunes", "Trailer", "Lo-Fi", "Tribal",
    "Acid Punk", "Acid Jazz", "Polka", "Retro",
    "Musical", "Rock & Roll", "Hard Rock", "Folk",
    "Folk/Rock", "National Folk", "Swing",
    "Fast-Fusion", "Bebob", "Latin", "Revival",
    "Celtic", "Bluegrass", "Avantgarde",
    "Gothic Rock", "Progressive Rock",
    "Psychedelic Rock", "Symphonic Rock", "Slow Rock",
    "Big Band", "Chorus", "Easy Listening",
    "Acoustic", "Humour", "Speech", "Chanson",
    "Opera", "Chamber Music", "Sonata", "Symphony",
    "Booty Bass", "Primus", "Porn Groove",
    "Satire", "Slow Jam", "Club", "Tango",
    "Samba", "Folklore", "Ballad", "Power Ballad",
    "Rhythmic Soul", "Freestyle", "Duet",
    "Punk Rock", "Drum Solo", "A Cappella",
    "Euro-House", "Dance Hall", "Goa",
    "Drum & Bass", "Club-House", "Hardcore",
    "Terror", "Indie", "BritPop", "Negerpunk",
    "Polsk Punk", "Beat", "Christian Gangsta Rap",
    "Heavy Metal", "Black Metal", "Crossover",
    "Contemporary Christian", "Christian Rock",
    "Merengue", "Salsa", "Thrash Metal",
    "Anime", "JPop", "Synthpop"
};

int read_tag(struct id3tag *tag, char *filename)
{
    char ident[4];
    FILE *file;
    int i;
    
    file = fopen(filename, "r");

    if(!file)
    {
	fprintf(stderr, "Cannot open file %s for reading.\n", filename);
	return(-1);
    }
    
    fseek(file, -128, SEEK_END);
    
    fread(ident, 1, 3, file);
    ident[3] = 0;
    
    if(strcmp(ident, "TAG"))
    {
	fclose(file);
	return(0);
    }
    
    fread(tag->title, 1, 30, file);
    tag->title[30] = 0;
    for(i = 29; i >= 0 && tag->title[i] == ' '; i--)
	tag->title[i] = 0;

    fread(tag->artist, 1, 30, file);
    tag->artist[30] = 0;
    for(i = 29; i >= 0 && tag->artist[i] == ' '; i--)
	tag->artist[i] = 0;

    fread(tag->album, 1, 30, file);
    tag->album[30] = 0;
    for(i = 29; i >= 0 && tag->album[i] == ' '; i--)
	tag->album[i] = 0;

    fread(tag->year, 1, 4, file);
    tag->year[4] = 0;

    fread(tag->comment, 1, 30, file);
    tag->comment[30] = 0;
    for(i = 29; i >= 0 && tag->comment[i] == ' '; i--)
	tag->comment[i] = 0;

    fread(&tag->genre, 1, 1, file);
    
    fclose(file);
    return(1);
}
