#include <stdio.h>

#include "info.h"

int bitrates[16][3][3] =
{{{   0,   0,   0}, {   0,   0,   0}, {   0,   0,   0}},
 {{  32,  32,  32}, {  32,  32,   8}, {  32,  32,   8}},
 {{  64,  64,  64}, {  64,  48,  16}, {  64,  48,  16}},
 {{  96,  56,  48}, {  96,  56,  24}, {  96,  56,  24}},
 {{ 128,  64,  56}, { 128,  64,  32}, { 128,  64,  32}},
 {{ 160,  80,  64}, { 160,  80,  64}, { 160,  80,  64}},
 {{ 192,  96,  80}, { 192,  96,  80}, { 192,  96,  80}},
 {{ 224, 112,  96}, { 224, 112,  56}, { 224, 112,  56}},
 {{ 256, 128, 112}, { 256, 128,  64}, { 256, 128,  64}},
 {{ 288, 160, 128}, { 288, 160, 128}, { 288, 160, 128}},
 {{ 320, 192, 160}, { 320, 192, 160}, { 320, 192, 160}},
 {{ 352, 224, 192}, { 352, 224, 112}, { 352, 224, 112}},
 {{ 384, 256, 224}, { 384, 256, 128}, { 384, 256, 128}},
 {{ 416, 320, 256}, { 416, 320, 256}, { 416, 320, 256}},
 {{ 448, 384, 320}, { 448, 384, 320}, { 448, 384, 320}},
 {{  -1,  -1,  -1}, {  -1,  -1,  -1}, {  -1,  -1,  -1}}};

int rates[4][3] =
{{ 44100, 22050, 11025},
 { 48000, 24000, 12000},
 { 32000, 16000,  8000}};

char *channel_modes[4] = { "Stereo",
			   "Joint stereo",
			   "Dual channel",
			   "Mono"};


int read_format(struct format *format, char *filename)
{
    int chr;
    FILE *file;
    
    file = fopen(filename, "r");
    
    if(!file)
    {   
	fprintf(stderr, "Cannot open file %s for reading.\n", filename);
	return(-1);
    }
    
    while(!feof(file))
    {
	for(chr = fgetc(file); chr != 0xFF; chr =  fgetc(file))
	    if(chr == EOF)
		break;
	if(chr == EOF)
	    break;
	
	chr = fgetc(file);
	if(chr == EOF)
	    break;
	
	if((chr & 0xE0) != 0xE0)
	    continue;
	
	format->mpeg = 4 - ((chr & 0x18) >> 3);
	if(format->mpeg > 2)
	    format->mpeg = 3;
	
	format->layer = 4 - ((chr & 0x06) >> 1);

	chr = fgetc(file);
	if(chr == EOF)
	    break;

	format->bitrate = 
	    bitrates[(chr & 0xF0) >> 4][format->mpeg - 1][format->layer - 1];
	
	format->rate = rates[(chr & 0x0C)][format->mpeg - 1];

	chr = fgetc(file);
	if(chr == EOF)
	    break;
	
	format->channel = ((chr & 0xC0) >> 6);
	fclose(file);
	return(1);

    }
    fclose(file);
    return(0);
}
