/* log.c -- Logging for musicdaemon player
 *
 * Copyright (C) 2002-2003 Petri Lahtinen <pjl@timefade.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdarg.h>

#include "main.h"
#include "log.h"


void log_printf(core *core, char *msg, ...)
{
    time_t now;
    char *timestamp;
    char *newline;
    va_list ap;

    if(core){}
    
    va_start(ap, msg);
    
    now = time(NULL);
    timestamp = ctime(&now);
    
    newline = strchr(timestamp, '\n');
    if(newline)
	*newline = 0;
    
    fprintf(stderr,"[%s] ", timestamp);
    vfprintf(stderr,msg, ap);
    fprintf(stderr,"\n");
}
