#ifndef NETWORK_H
#define NETWORK_H

#include <sys/select.h>

struct client;

#include "main.h"
#include "list.h"

typedef struct client
{
    int socket;
    int userlevel;
    int bufferfill;
    char buffer[512];
    list outbuf;
} client;

int listen_for_connections(int port);
int open_unix_socket(char *filename);
int wait_input(struct core *core, struct timeval *timeout);
int read_input(struct core *core, fd_set *fd, int num);
int new_client(struct core *core, int socket);
int remove_client(struct core *core, struct client *user);
int read_from_client(struct core *core, struct client *user);
int write_output(struct core *core, fd_set *fd, int num);
int send_to_client(struct core *core, struct client *user, char *message);
int client_printf(struct core *core, struct client *user, char *message, ...);
int broadcast(struct core *core, char *message);
void network_close(struct core *core);
int broad_printf(struct core *core, char *message, ...);

#endif
