#ifndef PLAYLIST_H
#define PLAYLIST_H

#include "musicd.h"
#include "list.h"

struct song;

typedef struct song
{
    char *file;			/* Filename with absolute path */
    struct metainfo info;	/* Song related metainfo */
} song;


typedef struct playlist
{
    char *name;		/* Name for the playlist, used for selecting */
    list songs;		/* Songs in playlist (struct song) */
    int position;	/* Current position in playlist */
} playlist;

int broadcast_songinfo(struct core *core, struct song *song);
int play_song(struct core *core, struct song *song);
int update_songinfo(struct core *core, struct song *song, int pos);
int copy_metainfo(struct metainfo *from, struct metainfo *to);
int free_metainfo(struct metainfo *info);

#endif
